/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.enums.EnumStage;
import de.ship.db.tables.TCoreElementHierarchy.TCoreElementHierarchyPath;
import de.ship.db.tables.TCoreVariable.TCoreVariablePath;
import de.ship.db.tables.records.TInputDisplayvarRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TInputDisplayvar extends TableImpl<TInputDisplayvarRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_input_displayvar</code>
     */
    public static final TInputDisplayvar T_INPUT_DISPLAYVAR = new TInputDisplayvar();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TInputDisplayvarRecord> getRecordType() {
        return TInputDisplayvarRecord.class;
    }

    /**
     * The column <code>common_dd.t_input_displayvar.lastchange</code>.
     */
    public final TableField<TInputDisplayvarRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_input_displayvar.pk</code>.
     */
    public final TableField<TInputDisplayvarRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>common_dd.t_input_displayvar.fk_formular</code>. foreign
     * key to key_element of referenced form
     */
    public final TableField<TInputDisplayvarRecord, Integer> FK_FORMULAR = createField(DSL.name("fk_formular"), SQLDataType.INTEGER.nullable(false), this, "foreign key to key_element of referenced form");

    /**
     * The column <code>common_dd.t_input_displayvar.fk_variable</code>. foreign
     * key to key_variable of variable to be displayed
     */
    public final TableField<TInputDisplayvarRecord, Integer> FK_VARIABLE = createField(DSL.name("fk_variable"), SQLDataType.INTEGER.nullable(false), this, "foreign key to key_variable of variable to be displayed");

    /**
     * The column <code>common_dd.t_input_displayvar.displayvar_posx</code>. x
     * position if input_layout = 2
     */
    public final TableField<TInputDisplayvarRecord, Integer> DISPLAYVAR_POSX = createField(DSL.name("displayvar_posx"), SQLDataType.INTEGER, this, "x position if input_layout = 2");

    /**
     * The column <code>common_dd.t_input_displayvar.displayvar_posy</code>. y
     * position if input_layout = 2
     */
    public final TableField<TInputDisplayvarRecord, Integer> DISPLAYVAR_POSY = createField(DSL.name("displayvar_posy"), SQLDataType.INTEGER, this, "y position if input_layout = 2");

    /**
     * The column <code>common_dd.t_input_displayvar.displayvar_order</code>.
     * order of variable if input_layout = 1
     */
    public final TableField<TInputDisplayvarRecord, Integer> DISPLAYVAR_ORDER = createField(DSL.name("displayvar_order"), SQLDataType.INTEGER, this, "order of variable if input_layout = 1");

    /**
     * The column <code>common_dd.t_input_displayvar.stage</code>. stage of
     * element
     */
    public final TableField<TInputDisplayvarRecord, EnumStage> STAGE = createField(DSL.name("stage"), SQLDataType.VARCHAR.nullable(false).defaultValue(DSL.field(DSL.raw("'stage.dev_test'::common_dd.enum_stage"), SQLDataType.VARCHAR)).asEnumDataType(EnumStage.class), this, "stage of element");

    private TInputDisplayvar(Name alias, Table<TInputDisplayvarRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TInputDisplayvar(Name alias, Table<TInputDisplayvarRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_input_displayvar</code> table
     * reference
     */
    public TInputDisplayvar(String alias) {
        this(DSL.name(alias), T_INPUT_DISPLAYVAR);
    }

    /**
     * Create an aliased <code>common_dd.t_input_displayvar</code> table
     * reference
     */
    public TInputDisplayvar(Name alias) {
        this(alias, T_INPUT_DISPLAYVAR);
    }

    /**
     * Create a <code>common_dd.t_input_displayvar</code> table reference
     */
    public TInputDisplayvar() {
        this(DSL.name("t_input_displayvar"), null);
    }

    public <O extends Record> TInputDisplayvar(Table<O> path, ForeignKey<O, TInputDisplayvarRecord> childPath, InverseForeignKey<O, TInputDisplayvarRecord> parentPath) {
        super(path, childPath, parentPath, T_INPUT_DISPLAYVAR);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TInputDisplayvarPath extends TInputDisplayvar implements Path<TInputDisplayvarRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TInputDisplayvarPath(Table<O> path, ForeignKey<O, TInputDisplayvarRecord> childPath, InverseForeignKey<O, TInputDisplayvarRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TInputDisplayvarPath(Name alias, Table<TInputDisplayvarRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TInputDisplayvarPath as(String alias) {
            return new TInputDisplayvarPath(DSL.name(alias), this);
        }

        @Override
        public TInputDisplayvarPath as(Name alias) {
            return new TInputDisplayvarPath(alias, this);
        }

        @Override
        public TInputDisplayvarPath as(Table<?> alias) {
            return new TInputDisplayvarPath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public Identity<TInputDisplayvarRecord, Integer> getIdentity() {
        return (Identity<TInputDisplayvarRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TInputDisplayvarRecord> getPrimaryKey() {
        return Keys.PK_INPUT_DISPLAYVAR;
    }

    @Override
    public List<UniqueKey<TInputDisplayvarRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.UK_INPUT_DISPLAYVAR);
    }

    @Override
    public List<ForeignKey<TInputDisplayvarRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_INPUT_DISPLAYVAR__FK_INPUTDISPLAYVAR_FORM, Keys.T_INPUT_DISPLAYVAR__FK_INPUTDISPLAYVAR_VAR);
    }

    private transient TCoreElementHierarchyPath _tCoreElementHierarchy;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_core_element_hierarchy</code> table.
     */
    public TCoreElementHierarchyPath tCoreElementHierarchy() {
        if (_tCoreElementHierarchy == null)
            _tCoreElementHierarchy = new TCoreElementHierarchyPath(this, Keys.T_INPUT_DISPLAYVAR__FK_INPUTDISPLAYVAR_FORM, null);

        return _tCoreElementHierarchy;
    }

    private transient TCoreVariablePath _tCoreVariable;

    /**
     * Get the implicit join path to the <code>common_dd.t_core_variable</code>
     * table.
     */
    public TCoreVariablePath tCoreVariable() {
        if (_tCoreVariable == null)
            _tCoreVariable = new TCoreVariablePath(this, Keys.T_INPUT_DISPLAYVAR__FK_INPUTDISPLAYVAR_VAR, null);

        return _tCoreVariable;
    }

    @Override
    public TInputDisplayvar as(String alias) {
        return new TInputDisplayvar(DSL.name(alias), this);
    }

    @Override
    public TInputDisplayvar as(Name alias) {
        return new TInputDisplayvar(alias, this);
    }

    @Override
    public TInputDisplayvar as(Table<?> alias) {
        return new TInputDisplayvar(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TInputDisplayvar rename(String name) {
        return new TInputDisplayvar(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TInputDisplayvar rename(Name name) {
        return new TInputDisplayvar(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TInputDisplayvar rename(Table<?> name) {
        return new TInputDisplayvar(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputDisplayvar where(Condition condition) {
        return new TInputDisplayvar(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputDisplayvar where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputDisplayvar where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputDisplayvar where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputDisplayvar where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputDisplayvar where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputDisplayvar where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputDisplayvar where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputDisplayvar whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputDisplayvar whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
